// 3DtestView.cpp : CMy3DtestView NX̎
//

#include "stdafx.h"
#include "3Dtest.h"

#include "3DtestDoc.h"
#include "3DtestView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMy3DtestView

IMPLEMENT_DYNCREATE(CMy3DtestView, CView)

BEGIN_MESSAGE_MAP(CMy3DtestView, CView)
	// WR}h
	ON_COMMAND(ID_FILE_PRINT, &CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, &CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, &CView::OnFilePrintPreview)
	ON_COMMAND(ID_FILE_OPEN, &CMy3DtestView::OnFileOpen)
	ON_COMMAND(ID_DISP0, &CMy3DtestView::OnDisp0)
	ON_COMMAND(ID_DISP1, &CMy3DtestView::OnDisp1)
	ON_COMMAND(ID_LAPLACIAN, &CMy3DtestView::OnLaplacian)
	ON_COMMAND(ID_FILE_SAVE_AS, &CMy3DtestView::OnFileSaveAs)
END_MESSAGE_MAP()

// CMy3DtestView RXgNV/fXgNV

CMy3DtestView::CMy3DtestView()
{
	// TODO: \zR[hɒǉ܂B

	jpgLoadFlag0=false;
	jpgLoadFlag1=false;

}

CMy3DtestView::~CMy3DtestView()
{
}

BOOL CMy3DtestView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ̈ʒu CREATESTRUCT cs C Window NX܂̓X^C
	//  CĂB

	return CView::PreCreateWindow(cs);
}

// CMy3DtestView `

void CMy3DtestView::OnDraw(CDC* pDC)
{
	CMy3DtestDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	// TODO: ̏ꏊɃlCeBu f[^p̕`R[hǉ܂B


	if(jpgLoadFlag0) 	{
		img0.Draw(pDC->m_hDC,0,0);
		jpgLoadFlag0=false;
	}
	if(jpgLoadFlag1) 	{
		img1.Draw(pDC->m_hDC,0,0);
		jpgLoadFlag1=false;
	}
}


// CMy3DtestView 

BOOL CMy3DtestView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// ̈
	return DoPreparePrinting(pInfo);
}

void CMy3DtestView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: O̓ʂȏǉĂB
}

void CMy3DtestView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: ̌㏈ǉĂB
}


// CMy3DtestView ff

#ifdef _DEBUG
void CMy3DtestView::AssertValid() const
{
	CView::AssertValid();
}

void CMy3DtestView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CMy3DtestDoc* CMy3DtestView::GetDocument() const // fobOȊÕo[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMy3DtestDoc)));
	return (CMy3DtestDoc*)m_pDocument;
}
#endif //_DEBUG


// CMy3DtestView bZ[W nh

void CMy3DtestView::OnFileOpen()
{
	// TODO: ɃR}h nh R[hǉ܂B

	FILE *infile;
	CString filename;

	CFileDialog dlg(true, _T("dat"), _T("*.dat"));
	if(dlg.DoModal()==IDOK)	{
		errno_t err = _wfopen_s(&infile, dlg.GetPathName(), L"r");   
	}
	BeginWaitCursor();
	size=100;
	for(int k=0; k<size; k++)
		for(int j=0; j<size; j++)
			for(int i=0; i<size; i++)
				fscanf(infile,"%f",&F0[i][j][k]);
	img0.Destroy();
	img1.Destroy();
	filename=_T("White.jpg");//ʓǂݍ
	img0.Load(filename);
	img1.Load(filename);
	jpgWidth=img0.GetWidth();
	jpgHeight=img0.GetHeight();
	jpgLoadFlag0=true;
	OnDisp0();
	EndWaitCursor();
}

void CMy3DtestView::OnDisp0()
{
	// TODO: ɃR}h nh R[hǉ܂B

	int i,j,k;
	BeginWaitCursor();
	int n=20;//XCXʐ
	int kk=size/n;//XCXXebv
	int p=-1;	int q=0;
	for(k=0; k<n; k++)	{
		p=p+1;
		if(p>=5)		{
			p=0;	q=q+1;
		}
		for(j=0; j<size; j++)	{
			for(i=0; i<size; i++)	{				
				img0.SetPixel(i+p*(size+2)+2,j+q*(size+2)+2,RGB(F0[i][j][k*kk],F0[i][j][k*kk],F0[i][j][k*kk]));
			}
		}
	}
	jpgLoadFlag0=true;
	InvalidateRect(NULL);
	EndWaitCursor();
}

void CMy3DtestView::OnDisp1()
{
	// TODO: ɃR}h nh R[hǉ܂B

	int i,j,k;
	BeginWaitCursor();
	int n=20;//XCXʐ
	int kk=size/n;//XCXXebv
	int p=-1;	int q=0;
	for(k=0; k<n; k++)	{
		p=p+1;
		if(p>=5)		{
			p=0;	q=q+1;
		}
		for(j=0; j<size; j++)		{
			for(i=0; i<size; i++)			{		
				img1.SetPixel(i+p*(size+2)+2,j+q*(size+2)+2,RGB(F1[i][j][k*kk],F1[i][j][k*kk],F1[i][j][k*kk]));
			}
		}
	}
	jpgLoadFlag1=true;
	InvalidateRect(NULL);
	EndWaitCursor();
}

void CMy3DtestView::OnLaplacian()
{
	// TODO: ɃR}h nh R[hǉ܂B

	int x,y,z;
	int f10,f20, f21,f23,f25,f27,f30;
	BeginWaitCursor();
	for(z=0; z<size; z++)
		for(y=0; y<size; y++)
			for(x=0; x<size; x++)
				F1[x][y][z]=0; // clear F1[x][y][z]
	for(z=1; z<size-1; z++)
		for(y=1; y<size-1; y++)
			for(x=1; x<size-1; x++) {
				f10=F0[x][y+1][z];
				f20=F0[x][y][z];
				f21=F0[x+1][y][z];
				f23=F0[x][y][z-1];
				f25=F0[x-1][y][z];
				f27=F0[x][y][z+1];
				f30=F0[x][y-1][z];
				F1[x][y][z]=f10+f21+f23+f25+f27+f30-6*f20;
			}
	OnDisp1();
	EndWaitCursor();

}

void CMy3DtestView::OnFileSaveAs()
{
	// TODO: ɃR}h nh R[hǉ܂B

	CString filename;
	//t@CĨ_CAOJ
	CFileDialog dlg(false,_T("jpg"),_T("*.jpg"),OFN_HIDEREADONLY |OFN_OVERWRITEPROMPT,_T("JPG Files (*.jpg)|*.jpg|All Files (*.*)|*.*||"));
	if (dlg.DoModal() == IDOK) 	{
	//_CAOőI΂ꂽt@C̖O擾
		filename = dlg.GetFileName();
		BeginWaitCursor();
		img1.Save(filename);
		EndWaitCursor();
	}
}
